#include "graduation_reserch.h"
#include "graphic_class.h"
#include "gr_subfunctions.h"

extern window W;
extern menu M;
menu Mu;
extern int endflag;
int last_flag = 0;
extern MyNode* root;
extern MyArc* aroot;
extern Cross_point* xroot;
MyGraph* G;
D3Graph* D;

MyNode* master = NULL;
MyNode* knot = NULL;

// Menu functions
void startup(void)
{
  //  M.button("string test", string_test);
  M.button("Graph open", Graphopen, graphopen);
  Mu.button("Graph open", Graphopen, graphopen);
  M.button("Graph save", Graphsave, graphsave);
  Mu.button("Graph save", Graphsave, graphsave);
  M.button("New", New, reflesh);
  M.button("Node insert", Nodeinsert, nodeinsert);
  M.button("Node delete", Nodedelete, nodedelete);
  M.button("Lastarize", Lastarize, lastarize);
  Mu.button("Free", Lastarize, lastarize);
  Mu.button("Cross point edit", Crossedit, crossedit);
  Mu.button("Run", Run, run);
  M.button("Exit", Exit, end);
  Mu.button("Exit", Exit, end);
  //  M.button("Simplex", simplex);
  //  M.button("draw circuit", dc);
  //  Mu.button("Triangulation", triangulation);
  //  Mu.button("Get Pillar", get_pillar);
  //  Mu.button("Get Tetrahedral", get_tetrahedral);
  //  Mu.button("Get 3D image from all", get_d3_all);
  Mu.button("Get simple image", get_simple_image);


  return;
}

void string_test(int flag = 0)
{
  M.close();
  W.read_mouse();
  W.draw_text(70, 70, "test...", color(0x00, 0x00, 0x00));
  W.draw_ctext("It can't use Japanese.", color(0x00, 0x00, 0x00));
return;
}

void graphopen(int flag = 0)
{
  fstream fin;
  string filename;
  string time = "yes";
  double x, y;
  MyNode* tp;
  node_array<vector> pos;
  node v;

  M.close();
  Mu.close();
  W.close();

  GRAPH<d3_point, int> T;

  do {
    cout << "Input the filename:";
    cin >> filename;
    if (strcmp(filename, "escape") == 0) {
      return;
    }
    fin.open(filename, std::ios::in);
    if (fin.fail()) {
      cout << "Open failure!!!" << endl;
      cout << "Please retype." << endl;
    }
  } while(fin.fail());

  if (last_flag == 0) {

    if (::root != NULL) {
      do {
	cout << "Are you sure to erase the current lines?(y or n):";
	cin >> time;
      } while(strcmp(time, "yes") != 0 && strcmp(time, "YES") != 0 && strcmp(time, "Yes") != 0 &&
	      strcmp(time, "y") != 0 && strcmp(time, "Y") != 0 &&
	      strcmp(time, "no") != 0 && strcmp(time, "NO") != 0 && strcmp(time, "No") != 0 &&
	      strcmp(time, "n") != 0 && strcmp(time, "N") != 0);
    }

    if (strcmp(time, "no") != 0 && strcmp(time, "NO") != 0 && strcmp(time, "No") != 0 &&
	strcmp(time, "n") != 0 && strcmp(time, "N") != 0) {   
      remove_lines();
      while (!fin.eof()) {
	fin >> x >> y;
	if (::root == NULL) {
	  tp = ::root = new MyNode(point(x, y));
	} else {
	  tp = tp->insert(point(x, y));
	}
      }
    }

    fin.close();
  } else {
    fin.close();

    ::W.display(window::center, window::center);
    T.read(filename);
    
    pos.init(T);

    forall_nodes(v, T) {
      pos[v] = T.inf(v).to_vector();
      //    T->hide_node(v);
      //    cout << T->inf(v) << endl;
    }

    d3_window d3win(::W, T, pos);

    d3win.set_draw_graph(true);
    ::W.set_bg_color(color(0x00, 0x00, 0x00));
    d3win.set_node_width(1);
    //  d3win.set_line_width(2);
    d3win.set_node_color(color(0xFF, 0x80, 0x00));
    d3win.set_edge_color(color(0xFF, 0x80, 0x00));
    /*
    forall_nodes(v, T) {
      if (::D->is_the_node_in_the_knot_from_all(v))
        d3win.set_color(v, color(0xFF, 0x00, 0x00));
      //    else
      //      d3win.set_node_width(v, 0);
    }
    forall_edges(e, T) {
      if (::D->is_the_edge_in_the_knot_from_all(e))
        d3win.set_color(e, color(0xFF, 0x00, 0x00));
    }
    */
    d3win.set_message
      ("\\bf\\white left:  \\green zoom up   ~~~~~\
        \\bf\\white middle:\\green zoom down ~~~~~\
        \\bf\\white right: \\green exit");
    d3win.draw();
  
    int but = 0;   
    while (but != MOUSE_BUTTON(3)) but = d3win.move();

    ::W.set_bg_color(color(0xFF, 0xFF, 0xFF));
  }
  return;
}

void graphsave(int flag = 0)
{
  fstream fout;
  string filename;
  string time;
  MyNode* tp;
  Cross_point* xp;
  GRAPH<d3_point, int>* T;


  M.close();
  Mu.close();

  W.clear();
  W.draw_ctext("Input filename on the tarminal.", color(0x00, 0x00, 0x00));
  W.close();

  do {
    cout << "Input the filename:";
    cin >> filename;
    if (strcmp(filename, "escape") == 0) {
      common_menuend();
      return;
    }
    ifstream t;
    t.open(filename);
    if (!t.fail()) {
      do {
	cout << "Over write?(y or n):";
	cin >> time;
      } while (strcmp(time, "yes") != 0 && strcmp(time, "YES") != 0 && strcmp(time, "Yes") != 0 &&
	       strcmp(time, "y") != 0 && strcmp(time, "Y") != 0 &&
	       strcmp(time, "no") != 0 && strcmp(time, "NO") != 0 && strcmp(time, "No") != 0 &&
	       strcmp(time, "n") != 0 && strcmp(time, "N") != 0);
      if (strcmp(time, "no") == 0 || strcmp(time, "NO") == 0 || strcmp(time, "No") == 0 ||
	  strcmp(time, "n") == 0 || strcmp(time, "N") == 0) {
	continue;
      }
    }
    fout.open(filename, std::ios::out);
    if (fout.fail()) {
      cout << "Open failure!!!" << endl;
      cout << "Please retype." << endl;
    }
  } while(fout.fail());
  if (last_flag == 0) {
    if (::root != NULL) {
      for (tp = ::root; tp != NULL; tp = tp->next) {
	fout << (tp->node).xcoord() << " " << (tp->node).ycoord() << endl;
      }
      if (last_flag != 0) {
	xp = ::xroot;
	while (xp != NULL) {
	  fout << xp->flag << endl;
	  xp = xp->next;
	}
      }    
    }
    fout.close(); 
  } else {
    fout.close();
    if (::D == NULL)
      get_d3_all(0);
    if (::D->NEIGHBOR == NULL)
      T = ::D->construct_neighborhood();
    else
      T = ::D->NEIGHBOR;
    T->write(filename);
  }
  return;
}

void reflesh(int flag = 0)
{
  M.close();
  Mu.close();

  remove_lines();

  return;
}

void nodeinsert(int flag = 0)
{
  point p;
  MyNode* tp;
  MyNode* root;

  M.close();
  Mu.close();

  root = ::root;

  W.clear();

  if (root != NULL) {
    draw_circuit();
  }

  if (root == NULL) {
    if (W >> p) {
      W.draw_point(p);
      ::root = root = tp = new MyNode(p);
	W.draw_point(p);
      while (W >> p) {
	tp = tp->insert(p);
	if (tp->before != NULL) {
	  W.draw_segment((tp->before)->node, tp->node);
	}
	W.draw_point(p);
      }
    }
  } else {
    if (root->next == NULL) {
      tp = root;
      while (W >> p) {
	tp = tp->insert(p);
	if (tp->before != NULL) {
	  W.draw_segment((tp->before)->node, tp->node);
	}
	W.draw_point(p);
      }
    } else {
      W >> p;
      tp = get_nearist(p);
      draw_circuit();
      W.set_color(color(0xFF, 0x00, 0x00));
      W.draw_point(tp->node);
      W.set_color(color(0x00, 0xFF, 0x00));
      W.draw_point((tp->next)->node);
      W.set_color(color(0x00, 0x00, 0x00));
      while (W >> p) {
	tp = tp->insert(p);
	if (tp->before != NULL) {
	  W.draw_segment((tp->before)->node, tp->node);
	}
	W.draw_point(p);
      }
    }
  }
  return;
}

void nodedelete(int flag = 0)
{
  point p;
  MyNode* tp;

  M.close();
  Mu.close();

  W.set_color(color(0x00, 0x00, 0x00));
  draw_circuit(::root);

  W.set_color(color(0xFF, 0x00, 0x00));
  while (W >> p) {
    tp = get_nearist(p);
    if (tp == ::root) {
      ::root = ::root->next;
    }

    W.draw_point(tp->node);

    delete tp;
  }
  return;
}

void lastarize(int flag = 0)
{
  MyNode* tp;
  //  cout << "start_lastarize" << endl;
  if (last_flag != 0) {
    while (::root->next != NULL) {
      delete ::root->next;
    }
    delete ::root;
    ::root = new MyNode(::master->node);
    tp = ::master->next;
    while (tp != NULL) {
      ::root->append(tp->node);
      tp = tp->next;
    }
    remove_ac();
    last_flag = 0;
  } else {
    tp = ::root->next;
    ::master = new MyNode(::root->node);
    while (tp != NULL) {
      ::master->append(tp->node);
      tp = tp->next;
    }
    //    cout << "start simplex" << endl;
    simplex_run();
    //    cout << "complete simplex" << endl;
    //    cout << "start get_arcs" << endl;
    get_arcs();
    //    cout << "complete get_arcs" << endl;
    //    cout << "start get_crosses" << endl;
    get_crosses();
    //    cout << "complete get_crosses" << endl;
    last_flag = 1;
  }
  //  cout << "complete lastarize" << endl;
  return;
}

void crossedit(int flag = 0)
{
  point p;
  Cross_point* tp;

  M.close();
  Mu.close();

  W.redraw();
  draw_shadow();

  tp = ::xroot;

  if (tp != NULL) {
    W.set_color(color(0x00, 0x00, 0xFF));
    while (tp != NULL) {
      W.draw_point(tp->x);
      tp = tp->next;
    }

    tp = ::xroot;
  
    while(W >> p){
      tp = get_nearist(p, tp);
      if (tp->flag == 'a') {
	tp->flag = 'b';
	W.set_color(color(0x00, 0xFF, 0x00));
	W.draw_segment((tp->a)->arc);
	W.set_color(color(0xFF, 0x00, 0x00));
	W.draw_segment((tp->b)->arc);
      } else {
	tp->flag = 'a';
	W.set_color(color(0x00, 0xFF, 0x00));
	W.draw_segment((tp->b)->arc);
	W.set_color(color(0xFF, 0x00, 0x00));
	W.draw_segment((tp->a)->arc);
      }
    }
  }
  return;
}

void run(int flag = 0)
{
  GRAPH<d3_point, int>* T;
  //  d3_window d3win();
  node_array<vector> pos;
  node v;
  edge e;
  Tetrahedral* tp;

  get_d3_all(0);

  T = ::D->construct_neighborhood();

  //  cout << "complete construct_neighborhood()" << endl;

  //  T = ::D->C_HULL;

  pos.init(*T);

  forall_nodes(v, *T) {
    pos[v] = T->inf(v).to_vector();
    //    T->hide_node(v);
    //    cout << T->inf(v) << endl;
  }

  d3_window d3win(::W, *T, pos);

  d3win.set_draw_graph(true);
  ::W.set_bg_color(color(0x00, 0x00, 0x00));
  d3win.set_node_width(1);
  //  d3win.set_line_width(2);
  d3win.set_node_color(color(0xFF, 0x80, 0x00));
  d3win.set_edge_color(color(0xFF, 0x80, 0x00));
  /*
  forall_nodes(v, *T) {
    if (::D->is_the_node_in_the_knot_from_all(v))
      d3win.set_color(v, color(0xFF, 0x00, 0x00));
    //    else
    //      d3win.set_node_width(v, 0);
  }
  forall_edges(e, *T) {
    if (::D->is_the_edge_in_the_knot_from_all(e))
      d3win.set_color(e, color(0xFF, 0x00, 0x00));
  }
  */
  d3win.set_message
    ("\\bf\\white left:  \\green zoom up   ~~~~~\
      \\bf\\white middle:\\green zoom down ~~~~~\
      \\bf\\white right: \\green exit");
  d3win.draw();
  
  int but = 0;   
  while (but != MOUSE_BUTTON(3)) but = d3win.move();

  ::W.set_bg_color(color(0xFF, 0xFF, 0xFF));

  return;
}

void end(int flag = 0)
{
  endflag = 0;
  return;
}

// Sub routines
void draw_circuit(void)
{
  draw_circuit(NULL);
  return;
}

void draw_circuit(MyNode* n)
{
  MyNode* tp;
  MyNode* root;

  if (n == NULL) {
    n = ::root;
  }

  W.set_color(color(0x00, 0x00, 0x00));

  if (n != NULL){
    tp = n;
    while(tp->before != NULL)
      tp = tp->before;
    root = tp;
    while(tp->next != NULL){
      W.draw_segment(tp->node, (tp->next)->node);
      tp = tp->next;
    }
    W.draw_segment(tp->node, root->node);
  }
  return;
}

void draw_lines(MyNode* x)
{
  draw_lines(x, NULL);
  return;
}

void draw_lines(MyNode* a, MyNode* b)
{
  MyNode* tp;

  if (a != NULL) {
    if (a->next != NULL) {
      tp = a;
      W.set_color(color(0x20, 0x40, 0x00));
      while (tp->next != b && tp->next != NULL) {
	W.draw_segment(tp->node, (tp->next)->node);
	tp = tp->next;
      }
    } else {
      W.draw_pixel(a->node);
    }
  }

  return;
}

void draw_points(MyNode* a, MyNode* b)
{
  MyNode* tp;

  if (a != NULL) {
    tp = a;
    W.set_color(color(0x00, 0x00, 0xFF));
    while (tp != b && tp != NULL) {
      W.draw_point(tp->node);
      tp = tp->next;
    }
    if (tp != NULL) {
      W.draw_point(tp->node);
    }
  }
  return;
}

void draw_shadow(void)
{
  Cross_point* xroot;
  Cross_point* t;
  t = ::xroot;

  draw_circuit();

  if (last_flag != 0) {
    while (t != NULL) {
      if (t->flag == 'a') {
	W.set_color(color(0x00, 0xFF, 0x00));
	if (t->b != NULL)
	  W.draw_segment((t->b)->arc);
	W.set_color(color(0xFF, 0x00, 0x00));
	if (t->a != NULL)
	  W.draw_segment((t->a)->arc);
      } else {
	W.set_color(color(0x00, 0xFF, 0x00));
	if (t->a != NULL)
	  W.draw_segment((t->a)->arc);
	W.set_color(color(0xFF, 0x00, 0x00));
	if (t->b != NULL)
	  W.draw_segment((t->b)->arc);
      }
      t = t->next;
    }
  } else {
    draw_circuit();
  }
  return;
}

void common_menuend(void)
{
  M.close();
  Mu.close();
  W.clear();
  W.display(window::center, window::center);
  draw_circuit(::root);
  if (last_flag != 0){
    draw_shadow();
    Mu.open(W, 0, 0);
  } else {
    M.open(W, 0, 0);
  }
  return;
}

MyNode* get_nearist(point p)
{
  return get_nearist(p, (MyNode*)NULL);
}

MyNode* get_nearist(point p, MyNode* n = NULL)
{
  MyNode* tp;
  MyNode* answer;

  if (n == NULL) {
    n = ::root;
  }

  tp = n->next;
  answer = n;

  while (tp != NULL) {
    if(p.distance(tp->node) < p.distance(answer->node))
      answer = tp;
    tp = tp->next;
  }

  return answer;
}

Cross_point* get_nearist(point p, Cross_point* x)
{
  Cross_point* tp;
  Cross_point* answer;

  answer = ::xroot;
  if (x != NULL)
    tp = ::xroot->next;
  else {
    tp = NULL;
  }

  while (tp != NULL) {
    if (p.distance(tp->x) < p.distance(answer->x)) {
      answer = tp;
    }
    tp = tp->next;
  }

  return answer;
}

void get_arcs(void)
{
  MyArc* aroot;
  MyNode* tp;
  MyArc* ap;
  remove_ac();

  tp = ::root->next;

  if (::root != NULL) {
    if (::root->next != NULL) {
      ::aroot = aroot = new MyArc(::root, ::root->next);
      ap = aroot;
      while (tp->next != NULL) {
	ap = ap->append(tp, tp->next);
	tp = tp->next;
      }
      ap->append(tp, ::root);
    }
  }
  return;
}

void get_crosses(void)
{
  Cross_point* root;
  Cross_point* xp;
  root = ::xroot;
  MyArc* aroot;
  MyArc* ap;
  MyArc* tap;

  if(::xroot != NULL) {
    while (::xroot->next != NULL)
      delete ::xroot->next;
    delete ::xroot;
  }

  ap = aroot = ::aroot;
  while (ap != NULL) {
    if (ap->next != NULL)
      tap = ap->next->next;
    while (tap != NULL) {
      if (tap != ap &&
	  tap->from->node != ap->from->node && tap->from->node != ap->to->node &&
	  tap->to->node   != ap->from->node && tap->to->node   != ap->to->node) {
	if (ap->is_cross(tap) == true) {
	  if (::xroot == NULL) {
	    xp = ::xroot = new Cross_point(ap, tap);
	  } else {
	    xp->append(ap, tap);
	  }
	}
      }
      tap = tap->next;
    }
    ap = ap->next;
  }
  return;

  /*
  ap = aroot = ::aroot;
  if (ap != NULL) {
    while (ap->next != NULL) {
      tap = (ap->next)->next;
      while (tap != NULL) {
	if ((ap == aroot && tap->next != NULL) || ap != aroot) {
	  if (ap->is_cross(tap)) {
	    if (root == NULL) {
	      xp = ::xroot = root = new Cross_point(ap, tap);
	    } else {
	      xp = xp->append(ap, tap);
	    }
	  }
	}
	tap = tap->next;
      }
      ap = ap->next;
    }
  }
  */
  return;
}

void simplex_run(void)
{
  MyArc* aroot;
  MyArc* ap;
  MyArc* tap;

  MyNode* tp;
  MyNode* pp;

  Time_arc T;

  get_arcs();
  //  cout << "complete get_arcs" << endl;

  aroot = ::aroot;
  ap = aroot;
  while (ap != NULL) {
    T.clean(ap);
    tap = aroot;
    while (tap != NULL) {
      if ((ap != aroot || tap->next != NULL) &&
	  (tap != aroot || ap->next != NULL) &&
	  ap != tap && ap->before != tap && ap->next != tap) {
	if (ap->is_cross(tap)) {
	  T.insert(ap, tap);
	}
      }
      tap = tap->next;
    }
    if (T.X != NULL){
      if ((T.X)->next != NULL){
	if (T.get_ancor() != NULL) {
	  tp = ap->from;
	  pp = T.N;
	  while (pp != NULL) {
	    tp = tp->insert(pp->node);
	    if (pp->center == true) 
	      tp->center = true;
	    pp = pp->next;
	  }
	  tp = (ap->from)->insert(T.N);
	}
      }
    }

    tp = ::root;
    while (tp != NULL) {
      if (tp->next != NULL) {
	while (tp->node == tp->next->node) {
	  delete tp->next;
	  if (tp->next == NULL)
	    break;
	}
      }
      tp = tp->next;
    }
    ap = ap->next;
  }

  ::W.clear();
  tp = ::root;
  while (tp != NULL) {
    //    ::W.set_color(color(rand() % 0x100, rand() % 0x100, rand() % 0x100));
    //    ::W.draw_point(tp->node);
    //    ::W.read_mouse();

    pp = ::root;
    while (pp != tp) {
      if (pp->node == tp->node) {
	tp = tp->before;
	delete tp->next;
	break;
      }
      pp = pp->next;
    }

    tp = tp->next;
  }

  remove_ac();
  // For one cross_point to only two segment.
  return;
}

void simplex(int flag)
{
  simplex_run();
  return;
}

void remove_ac(void)
{
  if (::aroot != NULL) {
    while (::aroot->next != NULL) {
      delete ::aroot->next;
    }
    delete ::aroot;
    ::aroot = NULL;
  }

  if (::xroot != NULL) {
    while (::xroot->next != NULL) {
      delete ::xroot->next;
    }
    delete ::xroot;
    ::xroot = NULL;
  }

  return;
}

void remove_lines(void)
{
  MyNode* root;

  root = ::root;
  if (root != NULL) {
    while (root->next != NULL) {
      delete root->next;
    }
    delete root;
    ::root = NULL;
  }
  return;
}

void dc(int flag = 0)
{
  MyNode* t;

  M.close();

  draw_circuit();
  t = ::root;

  while(t != NULL){
    W.set_color(color(0xFF, 0x00, 0x00));
    W.draw_point(t->node);
    t = t->next;
  }

  W.read_mouse();
  return;
}

/*
void remove_lines(void)
{
  MyNode* root;

  root = ::root;
  if (root != NULL) {
    while (root->next != NULL) {
      delete root->next;
    }
    delete root;
    ::root = NULL;
  }
  return;
}

void dc(int flag = 0)
{
  MyNode* t;

  M.close();

  draw_circuit();
  t = ::root;

  while(t != NULL){
    W.set_color(color(0xFF, 0x00, 0x00));
    W.draw_point(t->node);
    t = t->next;
  }

  W.read_mouse();
  return;
}
*/


void triangulation(int flag = 0)
{
  MyNode* path;
  MyArc*  knot;
  MyArc*  diagram;

  MyArc*  web;
  MyArc*  ap;

  MyNode* tp;
  MyNode* pp;
  Cross_point* xp; 

  point p;

  Mu.close();
  W.clear();

  ::knot = new MyNode(::root->node);
  tp = ::root->next;
  while (tp != NULL) {

    xp = ::xroot;
    while(xp != NULL) {
      if ((xp->a->from->node == tp->before->node && xp->a->to->node == tp->node) ||
	  (xp->a->from->node == tp->node && xp->a->to->node == tp->before->node)) {
	::knot->append(xp->x);
	if (xp->flag == 'a')
	  ::knot->tail()->upper = true;
      }
      if ((xp->b->from->node == tp->before->node && xp->b->to->node == tp->node) ||
	  (xp->b->from->node == tp->node && xp->b->to->node == tp->before->node)) {
	::knot->append(xp->x);
	if (xp->flag == 'b')
	  ::knot->tail()->upper = true;
      }
      /*
      pp = ::root;
      while (pp->next != NULL) {
	segment(tp->before->node, tp->node).intersection(segment(pp->node, pp->next->node), p);
	if (p == xp->x) {
	  ::knot->append(xp->x);
	}
	pp = pp->next;
      }
      */
      xp = xp->next;
    }

    ::knot->append(tp->node);
    if (tp->center == true)
      ::knot->tail()->center = true;
    tp = tp->next;
  }

  tp = ::root->tail();
  xp = ::xroot;
  while (xp != NULL) {
    if ((xp->a->from->node == tp->node && xp->a->to->node == ::root->node) ||
	(xp->a->from->node == ::root->node && xp->a->to->node == tp->node)) {
      ::knot->append(xp->x);
      if (xp->flag == 'a')
	::knot->tail()->upper = true;
      }
    if ((xp->b->from->node == tp->node && xp->b->to->node == ::root->node) ||
	(xp->b->from->node == ::root->node && xp->b->to->node == tp->node)) {
      ::knot->append(xp->x);
      if (xp->flag == 'b')
	  ::knot->tail()->upper = true;
    }
    xp = xp->next;
  }


  tp = ::knot;
  while (tp != NULL) {
    if (tp->center == true) { 
      tp = tp->before;
      delete tp->next;
    }
    tp = tp->next;
  }

  /*
  tp = ::root;
  while (tp != NULL) {
    ::W.set_color(color(rand() % 0x100, rand() % 0x100, rand() % 0x100));
    ::W.draw_point(tp->node);
    ::W.read_mouse();
    tp = tp->next;
  }
  ::W.clear();
  ::W.read_mouse();
  */

  knot = NULL;
  path = tp = ::knot;
  while (tp->next != NULL) {
    if (knot == NULL)
      ap = knot = new MyArc(tp, tp->next);
    else
      ap = knot->append(tp, tp->next);
    tp = tp->next;
  }
  tp = ::knot->tail();
  ap = knot->append(tp, ::knot);

  //  return;

  /*
  tp = ::root;
  while (tp != NULL) {
    pp = tp->next;
    if (tp->center == true) {
      delete tp;
    }
    tp = pp;
  }
  */

  /*
  pp = path = new MyNode(::root->node);
  tp = ::root;
  while (tp!= NULL) {
    xp = ::xroot;
    while (xp != NULL) {
      if (xp->a->from == tp) {
	path->append(xp->x);
	if (flag == 'a')
	  path->tail()->upper = true;
	if (knot == NULL) {
	  knot = new MyArc(pp, pp->next);
	} else {
	  knot->append(new MyArc(pp, pp->next));
	}
	pp = pp->next;
      }
      if (xp->b->from == tp) {
	path->append(xp->x);
	if (flag == 'b')
	  path->tail()->upper = true;
	if (knot == NULL) {
	  knot = new MyArc(pp, pp->next);
	} else {
	  knot->append(new MyArc(pp, pp->next));
	}
	pp = pp->next;
      }
      xp = xp->next;
    }
    if (tp->next != NULL){ 
      //      if (tp->next->center != true)
      path->append(tp->next->node);
      if (knot == NULL) {
	knot = new MyArc(pp, pp->next);
      } else {
	knot->append(new MyArc(pp, pp->next));
      }
      pp = pp->next;
    }
    tp = tp->next;
  }
  pp = path;
  while (pp != NULL) {
    if (pp == knot->tail()->to) {
      break;
    }
    pp = pp->next;
  }
  if (pp == NULL) {
    pp = knot->tail()->to;
  }

  knot->append(new MyArc(pp, path));

  ::W.clear();
  ap = knot;
  while (ap != NULL) {
    W.draw_segment(ap->arc);
    ap = ap->next;
    W.read_mouse();
  }

  W.read_mouse();

  // sleep();
  */
  ::W.clear();
  if (::G != NULL)
    delete ::G;
  ::G = new MyGraph(knot);

  /*
  ap = knot;
  while (ap != NULL) {
    ::W.set_color(color(rand() % 0x100, rand() % 0x100, rand() % 0x100));
    ::W.draw_segment(ap->arc);
    ::W.read_mouse();
    ap = ap->next;
  }
  ::W.clear();
  ::W.read_mouse();
  */

  ap = ::G->space_arcs;
  while (ap != NULL) {
    //    ::W.set_color(color(rand() % 0x100, rand() % 0x100, rand() % 0x100));
    //    ::W.draw_segment(ap->arc);
    //    ::W.read_mouse();
    ap = ap->next;
  }
  //  ::W.read_mouse();
  

  ::G->get_space();
  //  ::W.clear();
  //  ::W.read_mouse();
  ap = web = ::G->space_arcs;
  while (ap != NULL) {
    //    ::W.set_color(color(rand() % 0x100, rand() % 0x100, rand() % 0x100));
    //    ::W.draw_segment(ap->arc);
    //::W.read_mouse();
    ap = ap->next;
  }
  //  ::W.read_mouse();

  //  ::W.clear();
  //  ::W.read_mouse();

  return;
}

bool is_original(point p)
{
  MyNode* pp = ::master;
  while (pp != NULL) {
    if (pp->node == p) {
      return true;
    }
    pp = pp->next;
  }
  return false;
}

void make_knot(void)
{
  MyNode* tp;
  MyNode* pp;
  MyNode* kp;

  Cross_point* xp;

  if (::xroot == NULL)
    get_crosses();

  if (::knot != NULL) {
    //    cout << "delete knot" << endl;
    while (::knot->next != NULL) {
      delete ::knot->next;
    }
    delete ::knot;
  }

  tp = ::root;
  xp = ::xroot;

  //  if (::master == NULL)
  //    cout << "master failure!!" << endl;
  kp = ::knot = new MyNode(::root->node);

  tp = tp->next;
  while (tp != NULL){
    xp = ::xroot;
    while (xp != NULL) {
      if ((xp->a->from == tp && xp->a->to == tp->next) ||
	  (xp->a->to == tp && xp->a->from == tp->next)) {
	kp = kp->append(xp->x);
	if(xp->flag == 'a')
	  kp->upper = true;
      }
      if ((xp->b->from == tp && xp->b->to == tp->next) ||
	  (xp->b->to == tp && xp->b->from == tp->next)) {
	kp = kp->append(xp->x);
	if(xp->flag == 'b')
	  kp->upper = true;
      }
      xp = xp->next;
    }

    if (is_original(tp->node) == true)
      kp->append(tp->node);
    tp = tp->next;
  }

  tp = ::root->tail();
  xp = ::xroot;
  while (xp != NULL) {
    if ((xp->a->from == tp && xp->a->to == ::root) ||
	(xp->a->to == ::root && xp->a->from == tp)) {
      kp = kp->append(xp->x);
      if(xp->flag == 'a')
	kp->upper = true;
    }
    if ((xp->b->from == tp && xp->b->to == ::root) ||
	(xp->b->to == ::root && xp->b->from== tp)) {
      kp = kp->append(xp->x);
      if(xp->flag == 'b')
	kp->upper = true;
    }
    xp = xp->next;
  }

  return;

  /*
  while (tp != NULL) {
    while (pp->next != tp->next && tp->next != NULL) {
      if (xp->a->from == tp) {
	kp->append(xp->x);
	if (xp->flag == 'b') {
	  kp->upper = true;
	}
	xp = xp->next;
      }
      if (xp->b->from == tp) {
	kp->append(xp->x);
	if (xp->flag == 'a') {
	  kp->upper = true;
	}
	xp = xp->next;
      }
      tp = tp->next;
    }
    pp = pp->next; 
    tp = tp->next;
    if (pp != NULL)
      kp->append(pp->node);
  }
  ::W.read_mouse();

  ::W.clear();
  ::W.set_color(color(0x00, 0x00, 0x00));
  tp = ::knot;
  while (tp != NULL) {
    if (tp->next != NULL) {
      ::W.draw_segment(segment(tp->node, tp->next->node));
    }
    ::W.read_mouse();
    tp = tp->next;
  }
  */

  return;
}

void get_pillar(int flag = 0)
{
  MyArc* tp;

  triangulation();
  tp = ::G->space_arcs;
  /*
  while (tp) {
    ::W.set_color(color(rand() % 0x80, rand() % 0x80, rand() % 0x80));
    ::W.draw_segment(tp->arc);
    //    ::W.read_mouse();
    tp = tp->next;
  }
  */
  ::D = new D3Graph(knot, ::G);
  ::D->get_pillars();

  return;
}

void get_tetrahedral(int flag = 0)
{
  Pillar* pp;

  get_pillar();

  /*
  pp = ::D->cake;
  while (pp != NULL) {
    //    cout << "Pillar is there." << endl;
    pp = pp->next;
  }
  */

  ::D->get_tetrahedral();

  return;
}

void get_d3_all(int flag = 0)
{
  //  GRAPH<d3_point, int>* T;
  //  d3_window d3win();
  //  node_array<vector> pos;
  //  node v;
  //  edge e;
  //  Tetrahedral* tp;

  if (::D != NULL)
    delete ::D;

  get_tetrahedral();

  /*
  tp = ::D->space;
  while (tp != NULL) {
    //    cout << "Tetrahedral is there." << endl;
    tp = tp->next;
  }
  */

  ::D->construct_space();

  //  T = ::D->construct_neighborhood();

  return;
}

void get_simple_image(int flag = 0)
{
  GRAPH<d3_point, int>* T;
  //  d3_window d3win();
  node_array<vector> pos;
  node v;
  edge e;
  Tetrahedral* tp;

  get_d3_all();

  T = ::D->ALL;

  pos.init(*T);

  forall_nodes(v, *T) {
    pos[v] = T->inf(v).to_vector();
    //    cout << T->inf(v) << endl;
  }

  d3_window d3win(::W, *T, pos);

  d3win.set_draw_graph(true);
  ::W.set_bg_color(color(0x00, 0x00, 0x00));
  d3win.set_node_width(3);
  //  d3win.set_line_width(2);
  d3win.set_node_color(color(0x00, 0x00, 0xFF));
  d3win.set_edge_color(color(0x40, 0x40, 0x40));
  forall_nodes(v, *T) {
    if (::D->is_the_node_in_the_knot_from_all(v))
      d3win.set_color(v, color(0xFF, 0x00, 0x00));
    //    else
    //      d3win.set_node_width(v, 0);
  }
  forall_edges(e, *T) {
    if (::D->is_the_edge_in_the_knot_from_all(e))
      d3win.set_color(e, color(0xFF, 0x00, 0x00));
  }
  d3win.set_message
    ("\\bf\\white left:  \\green zoom up   ~~~~~\
      \\bf\\white middle:\\green zoom down ~~~~~\
      \\bf\\white right: \\green exit");
  d3win.draw();
  
  int but = 0;   
  while (but != MOUSE_BUTTON(3)) but = d3win.move();

  ::W.set_bg_color(color(0xFF, 0xFF, 0xFF));

  return;
}

// end
